from random import choice

class Sardinka:
    """Trieda reprezentujúca obeť"""
    def __init__(self, more, x = -1, y = -1):
        self.more = more
        if x == -1 and y == -1:
            volnemiesta = more.volneMiesta()
            if volnemiesta == []:
                raise Exception("Plné more!!!")
            x,y = choice(volnemiesta)
        self.x = x
        self.y = y
        self.interval = 2
        self.posmnoz = 0
        self.dospelost = 3
        self.vek = 0
        self.typ = 's'
    def _mlade(self,x,y):
        s = Sardinka(self.more,x,y)
        return s
    def pohyb(self):
        volne = self.more.blizkeVolno(self.x,self.y)
        if volne != []:
            x,y = choice(volne)
            self.more.presun(self, x, y)
        self.vek += 1
        self.posmnoz += 1
    def potomstvo(self):
        if self.vek >= self.dospelost and self.posmnoz >= self.interval:
            volne = self.more.blizkeVolno(self.x,self.y)
            if volne != []:
                x,y = choice(volne)
                novaRyba = self._mlade(x,y)
                self.more.pridajRybu(novaRyba)
                self.posmnoz = 0

class Zralok(Sardinka):
    """Trieda reprezentujúca predátora"""
    def __init__(self,more, x = -1, y = -1):
        Sardinka.__init__(self,more,x,y)
        self.interval = 3
        self.dospelost = 4
        self.typ = 'Z'
        self.nazratost = 1
        self.maxnazratost = 2
    def _mlade(self,x,y):
        s = Zralok(self.more,x,y)
        return s
    def pohyb(self):
        sardinka = self.more.blizkaSardinka(self.x,self.y)
        if sardinka == []:
            self.nazratost -= 1
            if self.nazratost < 0:
                self.more.uhyn(self)
            else:
                Sardinka.pohyb(self)
        else:
            x,y = choice(sardinka)
            self.more.zozer(self,x,y)
            self.vek += 1
            self.posmnoz += 1

class More:
    """Prostredie pre predátorov a obete"""
    def __init__(self,velkost = 20):
        self.more = []
        self.velkost = velkost
        for i in range(velkost):
            riadok = []
            for j in range(velkost):
                riadok.append('.')
            self.more.append(riadok)
        self.sardinky = []
        self.zraloky = []
    def pridajRybu(self,ryba):
        if self.more[ryba.x][ryba.y] == '.':
            self.more[ryba.x][ryba.y] = ryba.typ
            if ryba.typ == 's':
                self.sardinky.append(ryba)
            else:
                self.zraloky.append(ryba)
    def pridajSardinku(self):
        self.pridajRybu(Sardinka(self))
    def pridajZraloka(self):
        self.pridajRybu(Zralok(self))
    def volneMiesta(self):
        vm = []
        for i in range(self.velkost):
            for j in range(self.velkost):
                if self.more[i][j] == '.':
                    vm.append((i,j))
        return vm
    def _najdiBlizko(self,co,x,y):
        zoz = []
        for i in range(-1,2):
            for j in range(-1,2):
                if i == 0 and j == 0:
                    continue
                nx = (x+i) % self.velkost
                ny = (y+j) % self.velkost
                if self.more[nx][ny] == co:
                    zoz.append((nx,ny))
        return zoz
    def blizkeVolno(self,x,y):
        return self._najdiBlizko('.',x,y)
    def blizkaSardinka(self,x,y):
        return self._najdiBlizko('s',x,y)
    def presun(self,ryba,x,y):
        self.more[ryba.x][ryba.y] = "."
        self.more[x][y] = ryba.typ
        ryba.x, ryba.y = x,y
    def zozer(self,zralok,x,y):
        for i in range(len(self.sardinky)):
            if self.sardinky[i].x == x and self.sardinky[i].y == y:
                self.sardinky.pop(i)
                break
        self.more[zralok.x][zralok.y] = '.'
        self.more[x][y] = zralok.typ
        zralok.x, zralok.y = x,y
    def uhyn(self,zralok):
        self.zraloky.remove(zralok)
        self.more[zralok.x][zralok.y] = "."
    def vypis(self):
        for i in range(self.velkost):
            s = ""
            for j in range(self.velkost):
                s += self.more[i][j] + " "
            print(s)
    def pohyb(self):
        for i in self.sardinky:
            i.pohyb()
            i.potomstvo()
        for i in self.zraloky:
            i.pohyb()
            i.potomstvo()

m = More(30)
for i in range(60):
    m.pridajSardinku()
for i in range(6):
    m.pridajZraloka()
m.vypis()
while (input(':') != 'q'):
    m.pohyb()
    m.vypis()
